local mod = RW:Boss("Baltharus the Warborn", "The Ruby Sanctum")
local L

mod.BossIcon = [[Interface\Icons\INV_Misc_MonsterHead_01]]

---------------------------
-- Variables

-- Enervating Brand
local iBrand, wBrandClose, wBrandYou, tBrandCD

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.brand_close = "Enervating Brand target close, RUN!"
		L.brand_close_opt = "Warning when standing to close to the target"
		L.say_brand = "\"Say-message\" when you are the target of Enervating Brand"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(39751)
	self:SetWin()
	
	self:AddBoolOption("SayOnBrand", L.say_brand, nil, true, select(3, GetSpellInfo(74502)))
	
	-- Enervating Brand
	iBrand			= mod:Icon("SKULL", 74502, false, 10, "CROSS")
	wBrandClose		= mod:CustomWarning(L.brand_close, L.brand_close_opt, 74502)
	wBrandYou		= mod:OnYouWarning(74502)
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Brand", 74502)
	
	self:SendMessage("RW_ShowRangeCheck", true, 12)
end

function mod:Brand(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wBrandYou:Show()
			if self.db.profile.SayOnBrand then
				SendChatMessage("Brand on "..self.pName.."!", "SAY")
			end
		end
		iBrand:Show(args.dName)
		
		if self.Party.group[args.dName] then
			local uID = self.Party.group[args.dName].id
			if uID and CheckInteractDistance(uID, 2) then
				wBrandClose:Show()
			end
		end
	end
end


